SystemOrganization addCategory: #ConfigurationOfTabular!

Object subclass: #ConfigurationOfTabular
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfTabular'!

!ConfigurationOfTabular commentStamp: 'AlistairGrant 4/27/2016 02:59' prior: 0!
Metacello configuration for the Tabular project.

This configuration is normally posted to the following repositories: 

MCSmalltalkhubRepository
	owner: 'Pharo'
	project: 'MetaRepoForPharo50'
	user: ''
	password: ''

which exposes Tabular in the Catalog Browser, and:

MCGemstoneRepository
	location: 'http://ss3.gemstone.com/ss/Tabular'
	user: ''
	password: ''
	
which is the home of the Tabular project.!

!ConfigurationOfTabular class methodsFor: 'development support' stamp: 'VincentBlondeau 12/11/2014 10:46'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfTabular class methodsFor: 'private' stamp: 'VincentBlondeau 12/11/2014 10:46'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfTabular class methodsFor: 'catalog' stamp: 'VincentBlondeau 8/6/2015 11:15'!
catalogChangeLog
	"Returns a paragraph describing the most important changes in the configuration class."

	^ 'Not released yet!!'"
	- Version number - Date - topics
[[[
	ConfigurationOfXXX project version: ''xx'' ) load					
]]]"
! !

!ConfigurationOfTabular class methodsFor: 'catalog' stamp: 'VincentBlondeau 8/6/2015 11:15'!
catalogContactInfo
	"Returns a paragraph describing contact information such as email, mailing lists and website."

	^ 'Tabular is an amazing project . You can get in contact with our great Tabular programmers at assargaddon@gmail.com and vincent.blondeau@polytech-lille.net'! !

!ConfigurationOfTabular class methodsFor: 'catalog' stamp: 'AlistairGrant 4/27/2016 02:37'!
catalogDescription
	"Returns a paragraph describing the project"

	^ 'Tabular is an importer/exporter of Microsoft Office (import and export) and OpenOffice (import only) documents.'! !

!ConfigurationOfTabular class methodsFor: 'catalog' stamp: 'AlistairGrant 4/27/2016 14:33'!
catalogKeyClassesAndExample
	"Returns a paragraph or more describing the key classes of your project. You can use Pillar/Pier syntax to layout out the text i.e., ==Code== and - for bullet."

	^ 'An overview and description of the structure of Tabular is provided in ==TabularObject==.
	
To explore an ODS spreadsheet used in the automated tests, execute:

==| workbook worksheet |

workbook := ODSImporter fromStream: ODSImporterTest new workbook01 readStream.
worksheet := workbook worksheetNamed: ''Sheet1''.
worksheet show.
workbook inspect.
==


To explore an XLSX spreadsheet used in the automated test:

==| workbook worksheet |

workbook := XLSXImporter fromStream: TabularResources testExcelFile3WithAlignment readStream.
worksheet := workbook worksheetNamed: ''Sheet1''.
worksheet show.
workbook inspect.
==
'
! !

!ConfigurationOfTabular class methodsFor: 'catalog' stamp: 'AlistairGrant 4/27/2016 02:38'!
catalogKeywords
	"Returns an array of symbols"

	^ #(#XLSX #Excel #Importer #SAXHandler #'Office OpenXML' #Office #ODS)! !

!ConfigurationOfTabular class methodsFor: 'private' stamp: 'VincentBlondeau 12/11/2014 10:46'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfTabular class methodsFor: 'private' stamp: 'VincentBlondeau 12/11/2014 10:46'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfTabular class methodsFor: 'metacello tool support' stamp: 'VincentBlondeau 12/11/2014 10:46'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfTabular class methodsFor: 'loading' stamp: 'VincentBlondeau 12/11/2014 10:46'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfTabular class methodsFor: 'loading' stamp: 'VincentBlondeau 12/11/2014 10:46'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfTabular class methodsFor: 'loading' stamp: 'VincentBlondeau 12/11/2014 10:46'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfTabular class methodsFor: 'accessing' stamp: 'VincentBlondeau 12/11/2014 10:46'!
project

	^self new project! !

!ConfigurationOfTabular class methodsFor: 'development support' stamp: 'VincentBlondeau 12/11/2014 10:46'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfTabular methodsFor: 'baselines' stamp: 'VincentBlondeau 12/11/2014 10:47'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/Tabular'.
		spec package: 'Tabular'.
		spec group: 'Core' with: #('Tabular' ). ].
! !

!ConfigurationOfTabular methodsFor: 'baselines' stamp: 'VincentBlondeau 8/8/2015 11:31'!
baseline02: spec
	<version: '0.2-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/Tabular'.
		spec 
			project: 'XMLWriter' with: [
				spec
					className: #ConfigurationOfXMLWriter;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/PharoExtras/XMLWriter/main/' ];
			project: 'XMLParser' with: [
				spec
					className: #ConfigurationOfXMLParser;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/PharoExtras/XMLParser/main/' ].
		spec package: 'Tabular' with: [
				spec requires: #('XMLWriter' 'XMLParser' ). ].
		spec group: 'Core' with: #('Tabular' ). ].
! !

!ConfigurationOfTabular methodsFor: 'accessing' stamp: 'VincentBlondeau 12/11/2014 10:46'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfTabular methodsFor: 'symbolic versions' stamp: 'VincentBlondeau 8/8/2015 11:34'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.2-baseline'.
! !

!ConfigurationOfTabular methodsFor: 'accessing' stamp: 'VincentBlondeau 12/11/2014 10:46'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfTabular methodsFor: 'symbolic versions' stamp: 'VincentBlondeau 8/8/2015 11:34'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '0.2'.
! !

!ConfigurationOfTabular methodsFor: 'versions' stamp: 'VincentBlondeau 12/11/2014 11:00'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.1'.
		spec author: 'VincentBlondeau'.
		spec timestamp: '12/11/2014 11:00'.
		spec package: 'Tabular' with: 'Tabular-MYI.7'. ].
! !

!ConfigurationOfTabular methodsFor: 'versions' stamp: 'VincentBlondeau 8/8/2015 11:34'!
version02: spec
	<version: '0.2' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.2'.
		spec author: 'VincentBlondeau'.
		spec timestamp: '8/8/2015 11:34'.
		spec 
			project: 'XMLWriter' with: '2.6.2';
			project: 'XMLParser' with: '2.4.4'.
		spec package: 'Tabular' with: 'Tabular-HannesHirzel.28'. ].
! !

!ConfigurationOfTabular methodsFor: 'versions' stamp: 'AlistairGrant 4/22/2016 08:16'!
version03: spec
	<version: '0.3' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.3'.
		spec author: 'AlistairGrant'.
		spec timestamp: '22/4/2016 08:08'.
		spec 
			project: 'XMLWriter' with: '2.7.0';
			project: 'XMLParser' with: '2.7.6'.
		spec package: 'Tabular' with: 'Tabular-MYI.87'. ].
! !

!ConfigurationOfTabular methodsFor: 'versions' stamp: 'AlistairGrant 4/24/2016 08:22'!
version04: spec
	<version: '0.4' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.4'.
		spec author: 'AlistairGrant'.
		spec timestamp: '24/4/2016 08:18'.
		spec 
			project: 'XMLWriter' with: '2.7.0';
			project: 'XMLParser' with: '2.7.6'.
		spec package: 'Tabular' with: 'Tabular-AlistairGrant.90'. ].
! !
